"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// TODO?
function noise(x) {
    x ^= x << 13;
    x ^= x >> 17;
    x ^= x << 5;
    return x;
}
exports.noise = noise;
var BusHook = /** @class */ (function () {
    //target : Bus;
    function BusHook(bus, profiler) {
        //this.target = bus;
        var oldread = bus.read.bind(bus);
        var oldwrite = bus.write.bind(bus);
        bus.read = function (a) {
            profiler.logRead(a);
            var val = oldread(a);
            return val;
        };
        bus.write = function (a, v) {
            profiler.logWrite(a);
            oldwrite(a, v);
        };
        this.unhook = function () {
            bus.read = oldread;
            bus.write = oldwrite;
        };
    }
    return BusHook;
}());
exports.BusHook = BusHook;
var CPUClockHook = /** @class */ (function () {
    //target : CPU&ClockBased;
    function CPUClockHook(cpu, profiler) {
        //this.target = cpu;
        var oldclock = cpu.advanceClock.bind(cpu);
        cpu.advanceClock = function () {
            profiler.logExecute(cpu.getPC());
            return oldclock();
        };
        this.unhook = function () {
            cpu.advanceClock = oldclock;
        };
    }
    return CPUClockHook;
}());
exports.CPUClockHook = CPUClockHook;
var CPUInsnHook = /** @class */ (function () {
    //target : CPU&InstructionBased;
    function CPUInsnHook(cpu, profiler) {
        //this.target = cpu;
        var oldinsn = cpu.advanceInsn.bind(cpu);
        cpu.advanceInsn = function () {
            profiler.logExecute(cpu.getPC());
            return oldinsn();
        };
        this.unhook = function () {
            cpu.advanceInsn = oldinsn;
        };
    }
    return CPUInsnHook;
}());
exports.CPUInsnHook = CPUInsnHook;
/// DEBUGGING
var EmuBreakpoint = /** @class */ (function (_super) {
    __extends(EmuBreakpoint, _super);
    function EmuBreakpoint() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return EmuBreakpoint;
}(Error));
//# sourceMappingURL=nemu.js.map